﻿
// Note in output, that all exceptions wrapped in AggregateException ...
// Also note: TaskCancelledException inherits from OperationCancelledException

try {
	var cts = new CancellationTokenSource();
	cts.Cancel();
	var t = Task.FromCanceled<int>(cts.Token);
	t.Wait();
} catch (Exception ex) {
	Console.WriteLine(">>> Task.FromCanceled<int>(...) >>> .Wait() >>>");
	Console.WriteLine(ex);
}
Console.WriteLine();

try {
	var cts = new CancellationTokenSource();
	cts.Cancel();
	var t = Task.FromCanceled<int>(cts.Token);
	_ = t.Result;
} catch (Exception ex) {
	Console.WriteLine(">>> Task.FromCanceled<int>(...) >>> .Result getter >>>");
	Console.WriteLine(ex);
}
Console.WriteLine();

try {
	var t = Task.FromException<int>(new InvalidOperationException());
	t.Wait();
} catch (Exception ex) {
	Console.WriteLine(">>> Task.FromException<int>(...) >>> .Wait() >>>");
	Console.WriteLine(ex);
}
Console.WriteLine();

try {
	var t = Task.FromException<int>(new InvalidOperationException());
	_ = t.Result;
} catch (Exception ex) {
	Console.WriteLine(">>> Task.FromException<int>(...) >>> .Result getter >>>");
	Console.WriteLine(ex);
}
